         TITLE 'MEMORY MONITOR III'
;
;  COMPREHENSIVE 8080 MEMORY TEST
;
         ORG   0C900H
;
COOK:    CALL  SCONV         ;GET STARTING ADDRESS
         SHLD  START         ;AND IN MEMORY
         CALL  PSCAN         ;GET AMT OF MEMORY TO TEST
         SHLD  LENGTH        ;STORE LENGTH ALSO
         CALL  PSCAN         ;HOW MANY TIMES TO TEST ?
         MOV   C,A           ;SAVE IN 'C'
BEGIN:   PUSH  B             ;SAVE B & C
         CALL  CRLF          ;SEND A <CR><LF>
         POP   B             ;RESTORE B & C
         LHLD  LENGTH        ;STICK LENGTH IN H&L
         XCHG                ;NOW INTO D&E
         LHLD  START         ;AND START BACK INTO H&L
;
;   CLEAR ALL LOCATIONS TO BE TESTED
;
LOOP1:   XRA   A             ;CLEAR ACCUMULATOR (AND FLAGS)
         MVI   M,0           ;CLEAR TEST ADDRESS
         DCX   D             ;COUNT BYTES
         INX   H             ;INCREASE ADDRESS
         CMP   D             ;     ALL LOADED?
         JNZ   LOOP1         ;     IF NOT, DO
         CMP   E             ;     NEXT ADDRESS
         JNZ   LOOP1
;
;   NOW CHECK TO SEE IF ANY LOCATION
;   FAILED TO CLEAR
;
         LHLD  LENGTH        ;GET LENGTH BACK AGAIN
         XCHG                ;EVERYTHING IN ORDER NOW
         LHLD  START         ;GET START ADDRESS AGAIN
LOOP2:   XRA   A             ;CLEAR ACCUMULATOR (AND FLAGS)
         CMP   M             ;LOCATION CLEAR ?
         CNZ   PRNTA         ;FAILED ?  CALL PRINT A
         DCX   D             ;COUNT BYTES
         INX   H             ;INCREASE ADDRESS
         CMP   D             ;     ALL LOADED?
         JNZ   LOOP2         ;     IF NOT, DO
         CMP   E             ;     NEXT ADDRESS
         JNZ   LOOP2
;
;   NOW MAKE THE SECOND TEST -
;   ARE ALL THE LOCATIONS STILL CLEAR ?
;
         LHLD  LENGTH        ;ONCE AGAIN, GET LENGTH
         XCHG                ;AND SWITCH
         LHLD  START         ;AND GET START AGAIN
LOOP3:   XRA   A             ;CLEAR ACCUMULATOR
         CMP   M             ;LOCATION CLEAR ?
         CNZ   PRNTB         ;FAILED ?  CALL PRINT B
;
;   WALKING BIT TEST
;
         MVI   A,1           ;LOAD 0000 0001 IN ACCUMLATOR
LOOP4:   MOV   M,A           ;MOVE TO TEST LOCATION
         CMP   M             ;LOAD OK ?
         CNZ   PRNTC         ;FAILED ?  CALL PRINT C
         RAL                 ;ROTATE BIT LEFT
         JNC   LOOP4         ;8 BITS CHECKED ?
;
;   STORE ALL ONES
;
         MVI   A,11111111B   ;ALL ONES TO ACCUMULATOR
         MOV   M,A           ;MOVE TO TEST ADDRESS
         CMP   M             ;LOAD OK ?
         CNZ   PRNTD         ;FAILED ?  CALL PRINT D
         DCX   D             ;COUNT BYTES
         INX   H             ;INCREASE ADDRESS
         XRA   A             ;CLEAR ACCUMULATOR
         CMP   D             ;     ALL LOADED ?
         JNZ   LOOP3         ;     IF NOT, DO
         CMP   E             ;     NEXT ADDRESS
         JNZ   LOOP3
;
;   PRINT REPEAT SEPARATOR
;
         CALL  PRNTG         ;CALL PRINT <BEL>
         DCR   C             ;COUNT REPEATS
         XRA   A             ;CLEAR ACCUMULATOR
         CMP   C             ;ALL REPEATS DONE ?
         JNZ   BEGIN         ;IF NOT, GO DO AGAIN
         RZ                  ;ELSE RETURN TO SOLOS
;
;   FAILURE-PRINT SUBROUTINES
;
PRNTA:   MVI   B,'A'         ;LOAD A 'A'
         JMP   PRINT         ;GO TO COMMON PRINT ROUTINE
;
PRNTB:   MVI   B,'B'         ;LOAD A 'B'
         JMP   PRINT         ;GO TO COMMON PRINT ROUTINE
;
PRNTC:   MVI   B,'C'         ;LOAD A 'C'
         JMP   PRINT         ;GO TO COMMON PRINT ROUTINE
;
PRNTD:   MVI   B,'D'         ;LOAD A 'D'
         JMP   PRINT         ;GO TO COMMON PRINT ROUTINE
;
PRINT:   PUSH  PSW           ;SAVE FLAGS AND ACCUMULATOR
         PUSH  B             ;SAVE REPEAT COUNT
         PUSH  H             ;AND ADDRESS
         CALL  SOUT          ;PRINT ON CURRENT PSEUDO PORT
         POP   H             ;RESTORE ADDRESS
         CALL  ADOUT         ;ADDRESS OUTPUT ROUTINE IN SOLOS
         POP   B             ;RESTORE REPEAT COUNT
         POP   PSW           ;RESTORE FLAGS AND ACCUMULATOR
         RET                 ;GO BACK TO MM III
;
;   SEPARATOR CHARACTER PRINT SUBROUTINE
;
PRNTG:   PUSH  H             ;SAVE ADDRESS
         PUSH  B             ;SAVE REPEAT COUNT
         MVI   B,7           ;LOAD AN ASCII <BEL>
         CALL  SOUT          ;PRINT FROM SOLOS
         POP   B             ;RESTORE REPEAT COUNT
         POP   H             ;RESTORE ADDRESS
         RET                 ;RETURN TO MM III
;
;  PARAMETER STORAGE
;
START:   DW    0             ;STARTING ADDRESS TO TEST
LENGTH:  DW    0             ;LENGTH OF MEMORY TO TEST
;
;   SOLOS SYSTEM EQUIVALENCES
;
SCONV    EQU   0C33AH
PSCAN    EQU   0C310H
CRLF     EQU   0C2F9H
SOUT     EQU   0C019H
ADOUT    EQU   0C3E8H
;
;
         END
