         TITLE 'VDM DRIVER ROUTINE'
;
         ORG   0C900H
;
VDMOT:   PUSH  H
         PUSH  D
         PUSH  B
         LDA   ESCFL
         ORA   A
         JNZ   ESCS
CHPCK:   MOV   A,B
         ANI   7FH
         MOV   B,A
         JZ    GOBK
         LXI   H,TBL
         CALL  TSRCH
GOBACK:  CALL  VDADD
         CALL  GCH
         ORI   80H
         CALL  PCH
         LHLD  SPEED-1
         INR   L
         XRA   A
TIMER:   DCX   H
         CMP   H
         JNZ   TIMER
GOBK:    POP   B
         POP   D
         POP   H
         RET
NEXT:    INX   H
         INX   H
TSRCH:   MOV   A,M
         ORA   A
         JZ    CHAR
         CMP   B
         INX   H
         JNZ   NEXT
         PUSH  H
         CALL  CREM
         XTHL
         JMP   DISPT
CHAR:    MOV   A,B
         CPI   7FH
         RZ
OCHAR    EQU   $
         CALL  VDADD
         MOV   A,B
         CALL  PCH
         LDA   NCHAR
         CPI   63
         JC    OK
         LDA   LINE
         CPI   15
         JNZ   OK
SCROLL:  XRA   A
         STA   NCHAR
SROL:    MOV   C,A
         CALL  VDAD
         XRA   A
         CALL  CLIN1
         LDA   BOT
         INR   A
         ANI   0FH
         JMP   ERAS3
OK:      LDA   NCHAR
         INR   A
         ANI   3FH
         STA   NCHAR
         RNZ
PDOWN    EQU   $
         LDA   LINE
         INR   A
CURSC:   ANI   0FH
CUR:     STA   LINE
         RET
PERSE:   LXI   H,VDMEM
         MVI   A,80H+' '
         CALL  PCH
         INX   H
ERAS1    EQU   $
         MVI   A,' '
         CALL  PCH
         INX   H
         MOV   A,H
         CPI   (SHR (VDMEM + 400H) 8)
         JC    ERAS1
         STC
PHOME:   MVI   A,0
         STA   LINE
         STA   NCHAR
         RNC
ERAS3:   OUT   DSTAT
         STA   BOT
         RET
CLINE:   CALL  VDADD
         LDA   NCHAR
CLIN1:   CPI   64
         RNC
         PUSH  PSW
         MVI   A,' '
         CALL  PCH
         POP   PSW
         INX   H
         INR   A
         JMP   CLIN1
PUP:     LDA   LINE
         DCR   A
         JMP   CURSC
PLEFT:   LDA   NCHAR
         DCR   A
PCUR     EQU   $
         ANI   3FH
         STA   NCHAR
         RET
PRIT:    LDA   NCHAR
         INR   A
         JMP   PCUR
VDADD:   LDA   NCHAR
         MOV   C,A
VDAD2:   LDA   LINE
VDAD:    MOV   L,A
         LDA   BOT
         ADD   L
         RRC
         RRC
         MOV   L,A
         ANI   3
         ADI   (SHR (VDMEM) 8)
         MOV   H,A
         MOV   A,L
         ANI   0C0H
         ADD   C
         MOV   L,A
         RET
CREM:    CALL  VDADD
         CALL  GCH
         ANI   7FH
         CALL  PCH
         RET
PBACK:   CALL  PLEFT
         CALL  VDADD
         MVI   A,' '
         CALL  PCH
         RET
PCR:     CALL  CLINE
         JMP   PCUR
PLF:     LDA   LINE
         INR   A
         ANI   15
         JNZ   CUR
         JMP   SROL
PESC:    MVI   A,-1
         STA   ESCFL
         RET
ESCS:    CALL  CREM
         CALL  ESCSP
         JMP   GOBACK
ESCSP:   LDA   ESCFL
         CPI   -1
         JZ    SECOND
         LXI   H,ESCFL
         MVI   M,0
         CPI   2
         JC    SETX
         JZ    SETY
         CPI   8
         JZ    STSPD
         CPI   9
         JC    OCHAR
         RNZ
SETX:    MOV   A,B
         JMP   PCUR
SETY:    MOV   A,B
         JMP   CURSC
SECOND:  MOV   A,B
         CPI   3
         JZ    CURET
         CPI   4
         JNZ   ARET2
ARET:    MOV   B,H
         MOV   C,L
ARET1:   POP   H
         POP   D
         PUSH  B
         PUSH  H
         XRA   A
ARET2:   STA   ESCFL
         RET
CURET:   LXI   H,NCHAR
         MOV   B,M
         INX   H
         MOV   C,M
         JMP   ARET1
;
GCH:     PUSH  PSW
GC2:     IN    DSTAT
         ANI   1
         JNZ   GC2
         POP   PSW
         MOV   A,M
         RET
;
PCH:     PUSH  PSW
PC2:     IN    DSTAT
         ANI   1
         JNZ   PC2
         POP   PSW
         MOV   M,A
         RET
;
TBL:     DB    CLEAR-80H
         DW    PERSE
         DB    UP-80H
         DW    PUP
         DB    DOWN-80H
         DW    PDOWN
         DB    LEFT-80H
         DW    PLEFT
         DB    RIGHT-80H
         DW    PRIT
         DB    HOME-80H
         DW    PHOME
         DB    CR
         DW    PCR
         DB    LF
         DW    PLF
         DB    BACKS
         DW    PBACK
         DB    ESC
         DW    PESC
         DB    0
;
DOWN     EQU   9AH
UP       EQU   97H
LEFT     EQU   81H
RIGHT    EQU   93H
CLEAR    EQU   8BH
HOME     EQU   8EH
MODE     EQU   80H
BACKS    EQU   5FH
LF       EQU   10
CR       EQU   13
BLANK    EQU   ' '
SPACE    EQU   BLANK
CX       EQU   'X'-40H
ESC      EQU   1BH
VDMEM    EQU   0CC00H
ESCFL    EQU   0C80CH
SPEED    EQU   0C80BH
DISPT    EQU   0C227H
LINE     EQU   0C809H
NCHAR    EQU   0C808H
BOT      EQU   0C80AH
DSTAT    EQU   0FEH
STSPD    EQU   0C598H
;
         END
